home
***
CD-ROM
|
disk
|
FTP
|
other
***
search
/
PC World Komputer 2010 April
/
PCWorld0410.iso
/
hity wydania
/
Ubuntu 9.10 PL
/
karmelkowy-koliberek-desktop-9.10-i386-PL.iso
/
casper
/
filesystem.squashfs
/
usr
/
bin
/
ecryptfs-rewrite-file
< prev
next >
Wrap
Text File
|
2009-10-22
|
2KB
|
76 lines
#!/bin/sh -e
#
# ecryptfs-rewrite-file
# Copyright (C) 2008 Canonical Ltd.
#
# Authors: Dustin Kirkland <kirkland@canonical.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
TEXTDOMAIN="ecryptfs-utils"
error() {
echo `gettext "[FAILED]"`
echo `gettext "ERROR:"` "$1" 1>&2
}
j=0
OKs=0
for i in "$@"; do
j=`expr $j + 1`
echo -n `gettext "INFO:"` `gettext "Rewriting"` "[$j/$#] [$i] ... "
if [ ! -e "$i" ] ; then
error `gettext "File does not exist"`
continue
fi
if [ "$i" = "." ]; then
echo `gettext "[EXCLUDED]"` >&2
continue
fi
opt=
if [ -d "$i" -a ! -h "$i" ]; then
# A directory, re-encrypt the filename
temp1=`mktemp -d "$i".XXXXXXXXXX` || {
error `gettext "Could not create tempdir"`
continue
}
mv -f -T "$i" "$temp1" 2>/dev/null || {
error `gettext "Could not rename"` "[$i] -> [$temp1]"
rmdir "$temp1"
continue
}
mv -f "$temp1" "$i" 2>/dev/null || {
error `gettext "Could not rename"` "[$temp1] -> [$i]"
}
else
# A file or symlink, re-encrypt the contents
temp1=`mktemp "$i".XXXXXXXXXX` || {
error `gettext "Could not create tempfile"`
continue
}
cp -a "$i" "$temp1" 2>/dev/null || {
error `gettext "Could not copy"` "[$i] -> [$temp1]"
rm -f "$temp1"
continue
}
mv -f "$temp1" "$i" 2>/dev/null || {
error `gettext "Could not rename"` "[$temp1] -> [$i]"
continue
}
fi
echo `gettext "[OK]"`
OKs=$((OKs+1))
done
echo "$OKs/$j" `gettext "rewrites succeeded"`
[ $OKs -ne $j ] && exit 1
exit 0